//exec("base/addonpresets.cs");

if(isObject(elm_ap_loadPresetGui))
	elm_ap_loadPresetGui.delete();

//--- OBJECT WRITE BEGIN ---
new GuiControl(elm_ap_loadPresetGui) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 8";
   enabled = "1";
   visible = "1";
   clipToParent = "1";

   new GuiWindowCtrl() {
      profile = "BlockWindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "113 25";
      extent = "278 278";
      minExtent = "8 8";
      enabled = "1";
      visible = "1";
      clipToParent = "1";
      text = "Load an Add-on Preset";
      maxLength = "255";
      resizeWidth = "0";
      resizeHeight = "0";
      canMove = "1";
      canClose = "1";
      canMinimize = "0";
      canMaximize = "0";
      minSize = "50 50";
      closeCommand = "Canvas.popDialog(elm_ap_loadpresetgui);";

      new GuiScrollCtrl() {
         profile = "GuiScrollProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "25 47";
         extent = "231 162";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         willFirstRespond = "0";
         hScrollBar = "dynamic";
         vScrollBar = "dynamic";
         constantThumbHeight = "0";
         childMargin = "0 0";
         rowHeight = "40";
         columnWidth = "30";

         new GuiTextListCtrl(elm_ap_textlistctrl) {
            profile = "GuiTextListProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "1 1";
            extent = "214 2";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            enumerate = "0";
            resizeCell = "1";
            columns = "0";
            fitParentWidth = "1";
            clipColumnText = "0";
         };
      };
      new GuiButtonCtrl() {
         profile = "GuiButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "25 225";
         extent = "105 30";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         text = "Load";
         groupNum = "-1";
		 command = "elm_ap_loadGuiClick();";
         buttonType = "PushButton";
      };
      new GuiButtonCtrl() {
         profile = "GuiButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "151 225";
         extent = "105 30";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         text = "Delete";
		 command = "elm_ap_DeleteGuiClick();";
         groupNum = "-1";
         buttonType = "PushButton";
      };
   };
};
//--- OBJECT WRITE END ---

if(isObject(elm_ap_savePresetGui))
	elm_ap_loadPresetGui.delete();

//--- OBJECT WRITE BEGIN ---
new GuiControl(elm_ap_SavePresetGui) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 8";
   enabled = "1";
   visible = "1";
   clipToParent = "1";

   new GuiWindowCtrl() {
      profile = "BlockWindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "204 177";
      extent = "231 126";
      minExtent = "8 8";
      enabled = "1";
      visible = "1";
      clipToParent = "1";
      text = "Save an Add-on Preset";
      maxLength = "255";
      resizeWidth = "0";
      resizeHeight = "0";
      canMove = "1";
      canClose = "1";
      canMinimize = "0";
      canMaximize = "0";
      minSize = "50 50";
      closeCommand = "Canvas.popDialog(elm_ap_savePresetGui);";

      new GuiTextEditCtrl(elm_ap_presetText) {
         profile = "GuiTextEditProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "15 72";
         extent = "203 18";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         maxLength = "255";
         historySize = "0";
         password = "0";
         tabComplete = "0";
         sinkAllKeyEvents = "0";
      };
      new GuiSwatchCtrl() {
         profile = "GuiDefaultProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "15 31";
         extent = "202 35";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         color = "100 100 100 255";

         new GuiMLTextCtrl(ExampleChat) {
            profile = "HUDChatTextEditSize4Profile";
            horizSizing = "center";
            vertSizing = "top";
            position = "3 6";
            extent = "194 20";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            lineSpacing = "2";
            allowColorChars = "0";
            maxChars = "-1";
            text = "<just:center><font:impact:20>Preset Name";
            maxBitmapHeight = "-1";
            selectable = "1";
            autoResize = "1";
         };
      };
      new GuiButtonCtrl() {
         profile = "GuiButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "47 94";
         extent = "140 25";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         command = "elm_ap_clickSavePreset();";
         text = "Save";
         groupNum = "-1";
         buttonType = "PushButton";
      };
   };
};
//--- OBJECT WRITE END ---


if(isObject(customGameGui_loadPresetButton))
	customGameGui_loadPresetButton.delete();
	
if(isObject(customGameGui_SavePresetButton))
	customGameGui_savePresetButton.delete();
	
new GuiBitmapButtonCtrl(CustomGameGui_loadPresetButton) 
{
	profile = "ImpactForwardButtonProfile";
	horizSizing = "relative";
	vertSizing = "relative";
	position = "0 190";
	extent = "160 34";
	minExtent = "8 2";
	enabled = "1";
	visible = "1";
	clipToParent = "1";
	command = "elm_ap_loadClick();";
	text = "Load Preset > ";
	groupNum = "-1";
	buttonType = "PushButton";
	bitmap = "./client/ui/btnBlank";
	lockAspectRatio = "0";
	alignLeft = "0";
	alignTop = "0";
	overflowImage = "0";
	mKeepCached = "0";
	mColor = "255 255 255 255";
};

new GuiBitmapButtonCtrl(CustomGameGui_savePresetButton) 
{
	profile = "ImpactForwardButtonProfile";
	horizSizing = "relative";
	vertSizing = "relative";
	position = "0 220";
	extent = "160 34";
	minExtent = "8 2";
	enabled = "1";
	visible = "1";
	clipToParent = "1";
	command = "elm_ap_saveClick();";
	text = "Save Preset > ";
	groupNum = "-1";
	buttonType = "PushButton";
	bitmap = "./client/ui/btnBlank";
	lockAspectRatio = "0";
	alignLeft = "0";
	alignTop = "0";
	overflowImage = "0";
	mKeepCached = "0";
	mColor = "255 255 255 255";
};

customGameGui.add(CustomGameGui_loadPresetButton);
customGameGui.add(CustomGameGui_savePresetButton);

function elm_ap_save(%saveName,%overwrite)
{
	if(%savename $= "")
		return false;
		
	%path = "config/client/AddonPresets/";
	%d = discoverFile(%path @ %savename @ ".txt");
	
	if(%d && %overwrite $= "")
	{
		messageBoxYesNo("Warning","There is already a file with that name, would you like to overwrite it?","elm_ap_save(" @ %savename @ ",1);","");
		return false;
	}
	
	%ctrl = customGameGui_addonsBox;
	%count = %ctrl.getCount();
	
	%f = new fileObject();
	%f.openForWrite(%path @ %savename @ ".txt");
	
	for(%i=0;%i<%count;%i++)
	{
		%o = %ctrl.getObject(%i);
		
		eval("%isSelected = " @ %o.variable @ ";");
		
		if(%isSelected)
		{
			%f.writeLine(%o.varName);
		}
	}
	
	%f.close();
	%f.delete();
	
	elm_ap_save_music(%saveName);
}

function elm_ap_save_music(%saveName)
{
	if(%savename $= "")
		return false;
		
	%path = "config/client/AddonPresets/";
	
	%ctrl = customGameGui_musicBox;
	%count = %ctrl.getCount();
	
	%f = new fileObject();
	%f.openForAppend(%path @ %savename @ ".txt");
	
	for(%i=0;%i<%count;%i++)
	{
		%o = %ctrl.getObject(%i);
		
		eval("%isSelected = " @ %o.variable @ ";");
		
		if(%isSelected)
		{
			%f.writeLine(%o.varName);
		}
	}
	
	%f.close();
	%f.delete();	
}

function elm_ap_load(%name)
{
	if(%name $= "")
		return false;
		
	%path = "config/client/AddonPresets/";
	%ctrl = customGameGui_addonsBox;
	%count = %ctrl.getCount();
	
	%d = discoverFile(%path @ %name @ ".txt");
	
	if(!%d)
	{
		messageBoxOk("Attention","There is no file with that name, try again.");
		return false;
	}
	
	customGameGui.clickNone();
	
	%f = new fileObject();
	%f.openForRead(%path @ %name @ ".txt");
	
	while(!%f.isEof())
	{
		%line = %f.readLine();
		%container[%line] = true;
	}
	
	%f.close();
	%f.delete();
	
	for(%i=0;%i<%count;%i++)
	{
		%o = %ctrl.getObject(%i);
		
		if(%container[%o.varname])
		{
			$customGameGui::AddOnEnabled[%o.varname] = true;
			%o.setValue(1);
		}
	}
	
	elm_ap_load_music(%name);
}

function elm_ap_load_music(%name)
{
	if(%name $= "")
		return false;
		
	%path = "config/client/AddonPresets/";
	%ctrl = customGameGui_musicBox;
	%count = %ctrl.getCount();
	
	elm_ap_clearMusic();
	
	%f = new fileObject();
	%f.openForRead(%path @ %name @ ".txt");
	
	while(!%f.isEof())
	{
		%line = %f.readLine();
		%container[%line] = true;
	}
	
	%f.close();
	%f.delete();
	
	for(%i=0;%i<%count;%i++)
	{
		%o = %ctrl.getObject(%i);
		
		if(%container[%o.varname])
		{
			$customGameGui::MusicEnabled[%o.varname] = true;
			%o.setValue(1);
		}
	}
}

function elm_ap_clearMusic()
{
	%ctrl = customGameGui_musicBox;
	%count = %ctrl.getCount();	
	for(%i=0;%i<%count;%i++)
	{
		%o = %ctrl.getObject(%i);
		%o.setValue(0);
	}
}

function elm_ap_loadClick()
{
	canvas.pushDialog(elm_ap_loadPresetGui);
}

function elm_ap_saveClick()
{
	canvas.pushDialog(elm_ap_savePresetGui);
}

function elm_ap_loadPresetGui::onWake(%this)
{
	elm_ap_textListUpdate();
}

function elm_ap_textListUpdate()
{
	elm_ap_textListCtrl.clear();
	%path = "config/client/AddonPresets/";
	%c = getFileCount(%path @ "*.txt");
	
	for(%i=0;%i<%c;%i++)
	{	
		%file = findNextFile(%path @ "*.txt");
		%filename = strReplace(fileName(%file),fileExt(%file),"");
		elm_ap_textlistctrl.addRow(%i,%filename,0);
		
	}
}

function elm_ap_loadGuiClick()
{
	%id = elm_ap_textListCtrl.getSelectedId();
	%name = elm_ap_textListCtrl.getRowTextById(%id);
	
	elm_ap_load(%name);
	
	canvas.popDialog(elm_ap_loadPresetGui);
}

function elm_ap_deleteGuiClick()
{
	%path = "config/client/AddonPresets/";
	%id = elm_ap_textListCtrl.getSelectedId();
	%name = elm_ap_textListCtrl.getRowTextById(%id);
	
	if(isFile(%path @ %name @ ".txt"))
	{
		fileDelete(%path @ %name @ ".txt");
	}
	
	elm_ap_textListUpdate();
}

function elm_ap_clickSavePreset()
{
	%name = elm_ap_presetText.getValue();
	elm_ap_presetText.setValue("");
	
	if(%name $= "")
	{
		canvas.pushDialog(elm_ap_savePresetGui);
		return false;
	}
	
	elm_ap_save(%name);
	
	canvas.popDialog(elm_ap_savePresetGui);
}